// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SMApp.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_INSTALL, OnInstall)
	ON_UPDATE_COMMAND_UI(ID_INSTALL, OnUpdateInstall)
	ON_COMMAND(ID_REMOVE, OnRemove)
	ON_UPDATE_COMMAND_UI(ID_REMOVE, OnUpdateRemove)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

/*	manager.Install(this);
	manager.LoadToolbar(IDR_MAINFRAME);//*/

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnInstall() 
{
	if (hDevice!=INVALID_HANDLE_VALUE)
		return;
	SC_HANDLE sc=OpenSCManager(NULL,SERVICES_ACTIVE_DATABASE,
		SC_MANAGER_ALL_ACCESS);
	if (!sc)
	{
		AfxMessageBox(_T("You must have administrative priviledges to install SerMon device driver"),MB_OK);
		return;
	}

	CString s;
	GetCurrentDirectory(MAX_PATH,s.GetBuffer(MAX_PATH));
	s.ReleaseBuffer();
	if (s.Right(1)!=_T("\\"))
		s+=_T("\\");
	s+=_T("sermon.sys");

	SC_HANDLE hSrv;
	hSrv=CreateService(sc,_T("SerMon"),_T("SerMon"),SERVICE_ALL_ACCESS | GENERIC_EXECUTE | SERVICE_START | SERVICE_STOP,
		SERVICE_KERNEL_DRIVER,SERVICE_DEMAND_START,SERVICE_ERROR_IGNORE,
		s,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL);
	CloseServiceHandle(sc);
	if (!hSrv)
	{
		AfxMessageBox(_T("Unexpected error. Cannot create service"),MB_OK);
		return;
	}
	if (!StartService(hSrv,0,NULL))
	{
qq:		AfxMessageBox(_T("Cannot start device. SerMon.sys maybe not found"),MB_OK);
		DeleteService(hSrv);
		CloseServiceHandle(hSrv);
		return;
	}
	hDevice=CreateFile(_T("\\\\.\\SerMon"),GENERIC_READ | GENERIC_WRITE |
		GENERIC_EXECUTE,FILE_SHARE_WRITE | FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL |
		FILE_FLAG_OVERLAPPED,
		NULL);
	if (hDevice==INVALID_HANDLE_VALUE)
	{
		SERVICE_STATUS ss;
		ControlService(hSrv,SERVICE_CONTROL_STOP,&ss);
		goto qq;
	}
	CloseServiceHandle(hSrv);
	AfxMessageBox(_T("SerMon device driver successfully installed"),MB_OK);
}

void CMainFrame::OnUpdateInstall(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(hDevice==INVALID_HANDLE_VALUE);
}

void CMainFrame::OnRemove() 
{
	if (hDevice!=INVALID_HANDLE_VALUE)
		CloseHandle(hDevice);
	SC_HANDLE sc=OpenSCManager(NULL,SERVICES_ACTIVE_DATABASE,
		SC_MANAGER_ALL_ACCESS);
	if (sc)
	{
		SC_HANDLE hSrv=OpenService(sc,_T("SerMon"),SERVICE_START | SERVICE_STOP | DELETE);
		CloseServiceHandle(sc);
		if (hSrv)
		{
			SERVICE_STATUS ss;
			ControlService(hSrv,SERVICE_CONTROL_STOP,&ss);
			DeleteService(hSrv);
			CloseServiceHandle(hSrv);
			hDevice=INVALID_HANDLE_VALUE;
		} else
			AfxMessageBox(_T("Error. Cannot remove SerMon device driver"),MB_OK);
	}
}

void CMainFrame::OnUpdateRemove(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}
