// Serial Monitor.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SMApp.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "SMDoc.h"
#include "SMView.h"
#include "StartDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorApp

BEGIN_MESSAGE_MAP(CSerialMonitorApp, CWinApp)
	//{{AFX_MSG_MAP(CSerialMonitorApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_STARTMONITOR, OnStartmonitor)
	ON_UPDATE_COMMAND_UI(ID_STARTMONITOR, OnUpdateStartmonitor)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorApp construction

CSerialMonitorApp::CSerialMonitorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSerialMonitorApp object

CSerialMonitorApp theApp;
HANDLE hDevice=INVALID_HANDLE_VALUE;
CMultiDocTemplate* pDocTemplate;
bool OpenedPorts[255];

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorApp initialization

BOOL CSerialMonitorApp::InitInstance()
{
	memset(OpenedPorts,0,sizeof(bool)*250);

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	pDocTemplate = new CMultiDocTemplate(
		IDR_SERIALTYPE,
		RUNTIME_CLASS(CSerialMonitorDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CSerialMonitorView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
/*	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;//*/

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

// Try to open our device
	OSVERSIONINFO os;
	os.dwOSVersionInfoSize=sizeof(os);
	GetVersionEx(&os);
	if (os.dwPlatformId!=VER_PLATFORM_WIN32_NT)
	{
		AfxMessageBox(_T("This program can be run only on Windows NT platform"),MB_OK);
		return FALSE;
	}

	hDevice=CreateFile(_T("\\\\.\\SerMon"),GENERIC_READ | GENERIC_WRITE |
		GENERIC_EXECUTE,FILE_SHARE_WRITE | FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL |
		FILE_FLAG_OVERLAPPED,
		NULL);
	if (hDevice==INVALID_HANDLE_VALUE)	// no device
	{	// try to start it
		SC_HANDLE sc=OpenSCManager(NULL,SERVICES_ACTIVE_DATABASE,
			SC_MANAGER_ALL_ACCESS);
		if (!sc)
		{
			AfxMessageBox(_T("Serial Monitor cannot install device driver. You must have administrative ")
_T("privileges to install it."),MB_OK);
			return FALSE;
		}
// Try to find our device
		SC_HANDLE hSrv=OpenService(sc,_T("SerMon"),SERVICE_START | SERVICE_STOP |DELETE);
		CloseServiceHandle(sc);
		if (!hSrv)
		{
			AfxMessageBox(_T("Your system does not have SerMon device driver installed. Use option ")
_T("\"Settings\\Install...\" to install it."),MB_OK);
		} else
		{
// Start it
			if (!StartService(hSrv,0,NULL))
			{
				AfxMessageBox(_T("Unexpected error occured. SerMon device driver may be missing"),
					MB_OK);
				CloseServiceHandle(hSrv);
//				return FALSE;
			} else
			{
				CloseServiceHandle(hSrv);
				hDevice=CreateFile(_T("\\\\.\\SerMon"),GENERIC_READ | GENERIC_WRITE |
					GENERIC_EXECUTE,FILE_SHARE_WRITE | FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL |
					FILE_FLAG_OVERLAPPED,
					NULL);
				if (hDevice==INVALID_HANDLE_VALUE)
				{
					AfxMessageBox(_T("Unexpected error occured. Cannot get access to SerMon device driver"),
						MB_OK);
					return FALSE;
				}
			}
		}
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSerialMonitorApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorApp commands

int CSerialMonitorApp::ExitInstance() 
{
	if (hDevice!=INVALID_HANDLE_VALUE)
	{
		CloseHandle(hDevice);
		SC_HANDLE sc=OpenSCManager(NULL,SERVICES_ACTIVE_DATABASE,
			SC_MANAGER_ALL_ACCESS);
		if (sc)
		{
			SC_HANDLE hSrv=OpenService(sc,_T("SerMon"),SERVICE_START | SERVICE_STOP |DELETE);
			CloseServiceHandle(sc);
			if (hSrv)
			{
				SERVICE_STATUS ss;
				ControlService(hSrv,SERVICE_CONTROL_STOP,&ss);
				CloseServiceHandle(hSrv);
			}
		}
	}
	
	return CWinApp::ExitInstance();
}

void CSerialMonitorApp::OnStartmonitor() 
{
	CStartDlg dlg;
	if (dlg.DoModal()==IDOK)
	{
		CSerialMonitorDoc *pDoc=(CSerialMonitorDoc *) pDocTemplate->CreateNewDocument();
// Initialize my document
		if (pDoc->SetPort(dlg.m_Answer))
		{
			CFrameWnd *pFrame=pDocTemplate->CreateNewFrame(pDoc,NULL);
			pDocTemplate->InitialUpdateFrame(pFrame,pDoc);
		} else
		{
			pDocTemplate->RemoveDocument(pDoc);
			delete pDoc;
		}
	}
	
}

void CSerialMonitorApp::OnUpdateStartmonitor(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(hDevice!=INVALID_HANDLE_VALUE);
	
}
