// Serial MonitorDoc.cpp : implementation of the CSerialMonitorDoc class
//

#include "stdafx.h"
#include "SMApp.h"

#include "SMDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorDoc

IMPLEMENT_DYNCREATE(CSerialMonitorDoc, CDocument)

BEGIN_MESSAGE_MAP(CSerialMonitorDoc, CDocument)
	//{{AFX_MSG_MAP(CSerialMonitorDoc)
	ON_COMMAND(ID_STOPMONITOR, OnStopmonitor)
	ON_UPDATE_COMMAND_UI(ID_REMOVE, OnUpdateRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorDoc construction/destruction

CSerialMonitorDoc::CSerialMonitorDoc()
{
	// TODO: add one-time construction code here

}

CSerialMonitorDoc::~CSerialMonitorDoc()
{
}

BOOL CSerialMonitorDoc::OnNewDocument()
{
	ASSERT(FALSE);
	return FALSE;
/*	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;//*/
}



/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorDoc serialization

void CSerialMonitorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorDoc diagnostics

#ifdef _DEBUG
void CSerialMonitorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSerialMonitorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorDoc commands

BOOL CSerialMonitorDoc::SetPort(int port)
{
	m_Port=port;

	if (OpenedPorts[m_Port])
		return FALSE;

	DWORD dw;
	CString s;
	s.Format(L"\\??\\COM%d",m_Port);

	BOOL res=DeviceIoControl(hDevice,IOCTL_SERMON_STARTMONITOR,(PVOID) (LPCTSTR) s,
		(s.GetLength()+1)*sizeof(WCHAR),&handle,sizeof(MHANDLE),&dw,NULL);
	if (!res)
	{
		CString s;
		s.Format(_T("Cannot start monitor for %d communication port. Port maybe already opened"),m_Port);
		AfxMessageBox(s,MB_OK);
		return FALSE;
	}
	CString title;
	title.Format(_T("Serial port %d"),m_Port);
	SetTitle(title);

	OpenedPorts[m_Port]=true;
	return TRUE;
}

void CSerialMonitorDoc::OnCloseDocument() 
{
	AfxMessageBox(_T("You MUST close all applications that use this communication port before stopping."),MB_OK);
	DWORD dw;
	BOOL res=DeviceIoControl(hDevice,IOCTL_SERMON_STOPMONITOR,&handle,sizeof(MHANDLE),NULL,NULL,
		&dw,NULL);
	if (!res)
	{
		AfxMessageBox(_T("Unexpected error occured"),MB_OK);
	} else 
	{
		handle=NULL;
		OpenedPorts[m_Port]=false;
	}

	CDocument::OnCloseDocument();
}

void CSerialMonitorDoc::OnStopmonitor() 
{
	OnCloseDocument();
}

void CSerialMonitorDoc::OnUpdateRemove(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);	
}
