// Serial MonitorView.cpp : implementation of the CSerialMonitorView class
//

#include "stdafx.h"
#include "SMApp.h"

#include "SMDoc.h"
#include "SMView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorView

IMPLEMENT_DYNCREATE(CSerialMonitorView, CFormView)

BEGIN_MESSAGE_MAP(CSerialMonitorView, CFormView)
	//{{AFX_MSG_MAP(CSerialMonitorView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorView construction/destruction

CSerialMonitorView::CSerialMonitorView()
	: CFormView(CSerialMonitorView::IDD)
{
	//{{AFX_DATA_INIT(CSerialMonitorView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	Char1=Char2=Line1=Line2=0;

}

CSerialMonitorView::~CSerialMonitorView()
{
}

void CSerialMonitorView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerialMonitorView)
	DDX_Control(pDX, IDC_EDIT2, m_Edit2);
	DDX_Control(pDX, IDC_EDIT1, m_Edit1);
	//}}AFX_DATA_MAP
}

BOOL CSerialMonitorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorView printing

BOOL CSerialMonitorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSerialMonitorView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSerialMonitorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CSerialMonitorView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorView diagnostics

#ifdef _DEBUG
void CSerialMonitorView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSerialMonitorView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSerialMonitorDoc* CSerialMonitorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSerialMonitorDoc)));
	return (CSerialMonitorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSerialMonitorView message handlers

void CSerialMonitorView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
// Here we launch a parallel thread that will be issuing requests (GetInfoSize and GetInfo)
	hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
	ASSERT(hEvent);
	pThread=AfxBeginThread((AFX_THREADPROC) _Thread,this,THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED);
	ASSERT(pThread);
	pThread->m_bAutoDelete=FALSE;
	pThread->ResumeThread();
// OK.	
// Set tab stops
//	static const INT TabStops[]={10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,200};
	INT TabStops[17];
	for (int i=0;i<17;i++)
		TabStops[i]=i*14;
	TabStops[16]+=5;
	m_Edit1.SetTabStops(17,(INT *) TabStops);
	m_Edit2.SetTabStops(17,(INT *) TabStops);
	font.CreateFont(-8,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FIXED_PITCH | FF_MODERN,
		_T("Courier"));
	m_Edit1.SetFont(&font);
	m_Edit2.SetFont(&font);
}

UINT CSerialMonitorView::_Thread(CSerialMonitorView *pView)
{
	return pView->Thread();
}

UINT CSerialMonitorView::Thread(void)
{
// Issue GetInfoSize request
	DWORD Size,dw;
	OVERLAPPED over;
	over.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
	HANDLE hEvents[]={over.hEvent,hEvent};
	while (1)
	{
		BOOL res=DeviceIoControl(hDevice,IOCTL_SERMON_GETINFOSIZE,&GetDocument()->handle,sizeof(MHANDLE),
			&Size,sizeof(DWORD),&dw,&over);
		if (res==TRUE)	// request completed
		{
			if (dw==sizeof(DWORD) && Size)
				goto GetInfo;
		} else
		{
			if (GetLastError()!=ERROR_IO_PENDING)
				return 0;
			DWORD Res=WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
			BOOL flag=GetOverlappedResult(hDevice,&over,&dw,FALSE);
			if (Res==WAIT_OBJECT_0+1 || !flag)	// close
			{
//				CancelIo(hDevice);
				return 0;
			}
		}
GetInfo:
		LPBYTE p=new BYTE[Size];
		res=DeviceIoControl(hDevice,IOCTL_SERMON_GETINFO,&GetDocument()->handle,sizeof(MHANDLE),
			p,Size,&dw,&over);
		if (res==TRUE)	// request completed
		{
			ProcessIOReq((IOReq *) p);
			continue;
		}
		if (GetLastError()!=ERROR_IO_PENDING)
		{
			delete []p;
			return 0;
		}
		DWORD Res=WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
		BOOL flag=GetOverlappedResult(hDevice,&over,&dw,FALSE);
		if (Res==WAIT_OBJECT_0+1 || !flag)	// close
		{
//			CancelIo(hDevice);
			delete []p;
			return 0;
		}
		ProcessIOReq((IOReq *) p);
	}
}

void CSerialMonitorView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	SetEvent(hEvent);
	WaitForSingleObject(pThread->m_hThread,INFINITE);
	CloseHandle(hEvent);
	delete pThread;
}

void CSerialMonitorView::PrintBoth(LPCTSTR String)
{
	int last=m_Edit1.GetWindowTextLength();
	m_Edit1.SetSel(last,last);
	m_Edit1.ReplaceSel(_T("\x000d\x000a"));
	Char1=0;
	Line1++;	// next line
	int to=m_Edit1.LineIndex(Line1+1);
	if (to==-1)
		to=m_Edit1.GetWindowTextLength();
	int from=m_Edit1.LineIndex(Line1);
	m_Edit1.SetSel(from,to);
	m_Edit1.ReplaceSel(String);

	Line1++;

	last=m_Edit2.GetWindowTextLength();
	m_Edit2.SetSel(last,last);
	m_Edit2.ReplaceSel(_T("\x000d\x000a"));
	Char2=0;
	Line2++;	// next line
	to=m_Edit2.LineIndex(Line2+1);
	if (to==-1)
		to=m_Edit2.GetWindowTextLength();
	from=m_Edit2.LineIndex(Line2);
	m_Edit2.SetSel(from,to);
	m_Edit2.ReplaceSel(String);
	Line2++;
}

void CSerialMonitorView::ProcessIOReq(IOReq *p)
{
	union 
	{
		WCHAR chr;
		BYTE value;
	} temp;
	temp.chr=0;
	switch(p->type)
	{
	case REQ_OPEN:
	case REQ_CLOSE:	// these two requests will go in both windows
	{
		if (p->type==REQ_OPEN)
			PrintBoth(_T("Port opened\x000d\x000a"));
		else
			PrintBoth(_T("Port closed\x000d\x000a"));


		break;
	}
	case REQ_READ:
	{
		LPBYTE ptr=(LPBYTE) p+sizeof(IOReq);
		DWORD Size=p->SizeCopied;
		for (DWORD i=0;i<Size;i++)
		{
			if (Char1<=15)
				Symbols1[Char1++]=*ptr++;
			else
			{
// replace required string with new one
				CString s,t;
				for (int j=0;j<16;j++)
				{
					t.Format(_T("%02X\t"),Symbols1[j]);
					s+=t;
				}
				for (j=0;j<16;j++)
				{
					temp.value=(Symbols1[j]>=32)?Symbols1[j]:'.';
					t.Format(_T("%c"),temp.chr);
					s+=t;
				}
				s+="\x000d\x000a";
				int from=m_Edit1.LineIndex(Line1);
				int to=m_Edit1.LineIndex(Line1+1);
				if (to==-1) 
					to=m_Edit1.GetWindowTextLength();
				m_Edit1.SetSel(from,to,TRUE);
				m_Edit1.ReplaceSel(s);
				Line1++;
				Char1=1;
				Symbols1[0]=*ptr++;
			}
		}
// replace required string with new one
		if (Char1)
		{
			CString s,t;
			for (int j=0;j<16;j++)
			{
				if (j<Char1)
					t.Format(_T("%02X\t"),Symbols1[j]);
				else
					t=_T("\t");
				s+=t;
			}
			for (j=0;j<Char1;j++)
			{
				temp.value=(Symbols1[j]>=32)?Symbols1[j]:'.';
				t.Format(_T("%c"),temp.chr);
				s+=t;
			}
			s+="\x000d\x000a";
			int from=m_Edit1.LineIndex(Line1);
			int to=m_Edit1.LineIndex(Line1+1);
			if (to==-1) 
				to=m_Edit1.GetWindowTextLength();
			m_Edit1.SetSel(from,to);
			m_Edit1.ReplaceSel(s);
		}
		break;
	}
	case REQ_WRITE:
	{
		LPBYTE ptr=(LPBYTE) p+sizeof(IOReq);
		DWORD Size=p->SizeCopied;
		for (DWORD i=0;i<Size;i++)
		{
			if (Char2<=15)
				Symbols2[Char2++]=*ptr++;
			else
			{
// replace required string with new one
				CString s,t;
				for (int j=0;j<16;j++)
				{
					t.Format(_T("%02X\t"),Symbols2[j]);
					s+=t;
				}
				for (j=0;j<16;j++)
				{
					temp.value=(Symbols2[j]>=32)?Symbols2[j]:'.';
					t.Format(_T("%c"),temp.chr);
					s+=t;
				}
				s+=_T("\x000d\x000a");
				int from=m_Edit2.LineIndex(Line2);
				int to=m_Edit2.LineIndex(Line2+1);
				if (to==-1) 
					to=m_Edit2.GetWindowTextLength();
				m_Edit2.SetSel(from,to,TRUE);
				m_Edit2.ReplaceSel(s);
				Line2++;
				Char2=1;
				Symbols2[0]=*ptr++;
			}
		}
// replace required string with new one
		if (Char2)
		{
			CString s,t;
			for (int j=0;j<16;j++)
			{
				if (j<Char2)
					t.Format(_T("%02X\t"),Symbols2[j]);
				else
					t=_T("\t");
				s+=t;
			}
			for (j=0;j<Char2;j++)
			{
				temp.value=(Symbols2[j]>=32)?Symbols2[j]:'.';
				t.Format(_T("%c"),temp.chr);
				s+=t;
			}
			s+=_T("\x000d\x000a");
			int from=m_Edit2.LineIndex(Line2);
			int to=m_Edit2.LineIndex(Line2+1);
			if (to==-1) 
				to=m_Edit2.GetWindowTextLength();
			m_Edit2.SetSel(from,to);
			m_Edit2.ReplaceSel(s);
		}
		break;
	}
	case REQ_SETBAUDRATE:
	{
		CString s;
		s.Format(_T("Baud rate set to %d\x000d\x000a"),
			*(ULONG *) ((LPBYTE) p+sizeof(IOReq)));
		PrintBoth(s);
		break;
	}
	case REQ_SETLINECONTROL:
	{
		CString s;
		LPCTSTR temp;
		SERIAL_LINE_CONTROL *ptr=(SERIAL_LINE_CONTROL *) ((LPBYTE)p+sizeof(IOReq));

		switch(ptr->Parity)
		{
		case EVENPARITY:
			temp=_T("Even");
			break;
		case MARKPARITY:
			temp=_T("Mark");
			break;
		case NOPARITY:
			temp=_T("No");
			break;
		case ODDPARITY:
			temp=_T("Odd");
			break;
		case SPACEPARITY:
			temp=_T("Space");
			break;
		default:
			temp=_T("Strange");
			break;
		}

		s.Format(_T("StopBits: %s, Parity: %s parity, WordLength: %d\x000d\x000a"),
			((ptr->StopBits==ONESTOPBIT)?_T("1 stop bit"):((ptr->StopBits==ONE5STOPBITS)?
			_T("1.5 stop bits"):_T("2 stop bits"))),temp,
			ptr->WordLength);
		PrintBoth(s);
		break;
	}
	}
	delete [](LPBYTE) p;
}
